import os, time,sys
from time import gmtime, strftime
import shutil
import hashlib
import re
import zipfile

def find_latest_file(path,extensions):
    mtime = lambda f: os.stat(os.path.join(path, f)).st_mtime
    sortedlist = list(sorted(os.listdir(path), key=mtime,reverse=True))
    file_names = [fn for fn in sortedlist if any([fn.endswith(ext) for ext in extensions])];
    return (file_names[0])

def append_log(filename,log):
    f1=open(filename, 'a')
    message = timestamp + ' : ' + log 
    print message
    f1.write(message)
    f1.closed

def md5(fileName):
    """Compute md5 hash of the specified file"""
    m = hashlib.md5()
    try:
        fd = open(fileName,"rb")
    except IOError:
        print "Reading file has problem:", filename
        return
    x = fd.read()
    fd.close()
    m.update(x)
    return m.hexdigest()

def updateReleaseNotesEx(fileName,content_array):
#    print fileName
#    print content_array
    tmpfile = fileName+".log"
#    print tmpfile
    with open(tmpfile, "wt") as fout:
        with open(fileName, "rt") as fin:
            for line in fin:
                line_replace=""
                for sr in content_array:
                    if (line.find(sr[0])!=-1):
                        line_replace = sr[1]                        
                if (line_replace =="") :
                    fout.write(line)
                else :
                    fout.write(line_replace+'\n')
    fout.close()
    fin.close()
    shutil.copy(tmpfile, fileName)
    os.remove(tmpfile)
            
def zipdir(zip_dir, zip_file):
    zip = zipfile.ZipFile(zip_file, 'w', zipfile.ZIP_DEFLATED)
    file_path = zip_dir.split('\\')
    rootlen = len(zip_dir) - len(file_path[len(file_path)-1])
    for base, dirs, files in os.walk(zip_dir):
       for file in files:
          fn = os.path.join(base, file)
          if ((file[-2:]!='.o') and (file[-2:]!='.d') and (file[-2:]!='.1') and (file[-4:]!='.crf')):
              zip.write(fn, fn[rootlen:])
    zip.close()

def searchLine(fileName,line_array):
    lines=[]
    with open(fileName, "rt") as fin:
        for line in fin:
            for sr in line_array:
                if (line.find(sr[0])!=-1):
                    lines.append(line)                        
    fin.close()    
    return lines

def trimspace(content):
    tStr = content.strip()
    for num in range(0,10): 
        tStr = tStr.replace('  ',' ')
        tStr = tStr.replace('      ',' ')
    return tStr


# ----------------------------------------------------------------------------
version ="nordic hex backup version 20140327"   
timestamp = (time.strftime("%y%m%d_%H%M%S"))
output_path = 'C:/myData/myCloud/Dropbox/d2m_projects/melon/firmware/hex'
release_path = './hex_release'
release_file = release_path + '/release_notes.txt'

build_path = os.getcwd() + '/_build'
project_path = os.getcwd().replace('\\arm','')
build_extension = 'hex'
#print build_path, build_extension , output_path
print version

latest_hex = find_latest_file(build_path,build_extension)
latest_map = find_latest_file(build_path,'map')
#print latest_map
#print latest_hex
sline=[]
sline.append('Grand Totals')
searchedLine =  searchLine(build_path+'\\'+latest_map,sline)
#MemoryTotal = trimspace(searchedLine[len(searchedLine)-1].replace('Grand Totals',''))
MemoryTotal = (searchedLine[len(searchedLine)-1].replace('Grand Totals',''))
#print MemoryTotal.split(' ')
print MemoryTotal

# remove previous .hex file
files = os.listdir(release_path)
fileName = latest_hex.replace('.hex','')
for f in files:
#  print release_path+'/'+f + ':' + fileName
  if not os.path.isdir(f) and fileName in f:
    os.remove(release_path+'/'+f)
#    print 'removed'
         
#sys.exit()


src = build_path + '/' + latest_hex
src_hex = src
dst = output_path + '/' + latest_hex
shutil.copy(src, dst)
append_log ('./hex_backup.txt', 'copy ' + latest_hex + ' to ' + dst + '\n')

dst = release_path + '/' + latest_hex
shutil.copy(src, dst)
append_log ('./hex_backup.txt', 'copy ' + latest_hex + ' to ' + dst + '\n')

dst = release_path + '/' + latest_hex.replace('.hex','.'+timestamp+'.hex')
shutil.copy(src, dst)
append_log ('./hex_backup.txt', 'copy ' + latest_hex + ' to ' + dst + '\n')

dst = output_path + '/hex_archive/' + latest_hex.replace('.hex','.'+timestamp+'.hex')
shutil.copy(src, dst)
append_log ('./hex_backup.txt', 'copy ' + latest_hex + ' to ' + dst + '\n')


hex_size = os.path.getsize(src_hex)
md5_hex_file = md5(src_hex)

s0=[]
s_content = "$Latest HEX File$"
r_content = "    $Latest HEX File$ : " + latest_hex + " : " + str(hex_size) + " : " + md5_hex_file
s0.append([s_content,r_content])

s_content = "$Relase Date$"
r_content = "    $Relase Date$     : " + timestamp
s0.append([s_content,r_content])

s_content = "$Memory Total$"
r_content = "    $Memory Total$    : " + MemoryTotal
s0.append([s_content,r_content])


# convert to bin file for OTA

#C:\Keil\ARM\ARMCC\BIN\fromelf.exe .\_build\ble_app_melon.axf --output  .\_build\ble_app_melon.bin --bin
fromelf_path = 'C:\\Keil\\ARM\\ARMCC\\BIN\\fromelf.exe'
axf_file = latest_hex.replace(".hex",".axf")
bin_file = latest_hex.replace(".hex",".bin")
cmd = fromelf_path + ' .\\_build\\' + axf_file + ' --output .\\_build\\' + bin_file + ' --bin'
#print cmd
os.system(cmd)

src = build_path + '/' + bin_file
src_bin = src
dst = output_path + '/' + bin_file

if (os.path.isfile(src_bin) == 1) :
    
    shutil.copy(src, dst)
    append_log ('./hex_backup.txt', 'copy ' + bin_file + ' to ' + dst + '\n')

    dst = release_path + '/' + bin_file
    shutil.copy(src, dst)
    append_log ('./hex_backup.txt', 'copy ' + bin_file + ' to ' + dst + '\n')

    dst = output_path + '/hex_archive/' + bin_file.replace('.bin','.'+timestamp+'.bin')
    shutil.copy(src, dst)
    append_log ('./hex_backup.txt', 'copy ' + bin_file + ' to ' + dst + '\n')

    bin_size = os.path.getsize(src_bin)
    md5_bin_file = md5(src_bin)
    s_content = "$Latest BIN File$"
    r_content = "    $Latest BIN File$ : " + latest_hex.replace('hex','bin') + " : " + str(bin_size) + " : " + md5_bin_file
    s0.append([s_content,r_content])


updateReleaseNotesEx(release_file,s0)

target_dir = project_path
zip_file = 'c://myData//myCloud//working_backup//melon//'+latest_hex.replace('.hex','.'+timestamp+'.zip')
zipdir(target_dir,zip_file)



